'use strict';

const rfr = require("rfr");
const inExtensions = rfr("lib/path/in-extensions");
const findMatchingBasenames = rfr("lib/filesets/find-matching-basenames");

module.exports = function(item, allItems) {
	let matchExtensions = [
		".mp4",
		".mkv",
		".flv",
		".avi",
		".ogv",
		".mpeg",
		".wmv"
	]

	let setExtensions = [
		".vtt",
		".srt",
		".sub"
	];

	let match = inExtensions(item.name, matchExtensions);

	if (match) {
		return findMatchingBasenames(item.name, match, Object.keys(allItems), setExtensions);
	} else {
		return [];
	}
}